import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;

public class StringProcess {
    char[] R=new char[10];
    String[] S=new String[10];
    int s[]=new int[10];
    int t[]=new int[10];
    int count;

    public StringProcess() {}


    public static String rotateLeft(String S) {
	String T=S.substring(1,S.length())+S.substring(0,1);
	return(T);
    }

    public static String rotateRight(String S) {
	String T=S.substring(S.length()-1,S.length())+S.substring(0,S.length()-1);
	return(T);
    }


    public static String allCaps(String TEMP) {
	String S=new String();
	for(int i=0;i<TEMP.length();++i) {
	    if(TEMP.charAt(i)=='a') S=S+"A";
	    if(TEMP.charAt(i)=='A') S=S+"A";
	    if(TEMP.charAt(i)=='b') S=S+"B";
	    if(TEMP.charAt(i)=='B') S=S+"B";
	    if(TEMP.charAt(i)=='x') S=S+"X";
	    if(TEMP.charAt(i)=='X') S=S+"X";
	    if(TEMP.charAt(i)=='[') S=S+"[";
	    if(TEMP.charAt(i)=='(') S=S+"(";
	}
	return(S);
    }

    public static int getNumber(String TEMP) {
	int n=1;
	int sign=1;
	if(TEMP.charAt(0)=='-') {
                               sign=-1;
	             if(TEMP.charAt(1)=='0') n=0;
	             if(TEMP.charAt(1)=='1') n=1;
	             if(TEMP.charAt(1)=='2') n=2;
	             if(TEMP.charAt(1)=='3') n=3;
	             if(TEMP.charAt(1)=='4') n=4;
	             if(TEMP.charAt(1)=='5') n=5;
	             if(TEMP.charAt(1)=='6') n=6;
	             if(TEMP.charAt(1)=='7') n=7;
	             if(TEMP.charAt(1)=='8') n=8;
	             if(TEMP.charAt(1)=='9') n=9;
	}

	if(TEMP.charAt(0)!='-') {
	             if(TEMP.charAt(0)=='0') n=0;
	             if(TEMP.charAt(0)=='1') n=1;
	             if(TEMP.charAt(0)=='2') n=2;
	             if(TEMP.charAt(0)=='3') n=3;
	             if(TEMP.charAt(0)=='4') n=4;
	             if(TEMP.charAt(0)=='5') n=5;
	             if(TEMP.charAt(0)=='6') n=6;
	             if(TEMP.charAt(0)=='7') n=7;
	             if(TEMP.charAt(0)=='8') n=8;
	             if(TEMP.charAt(0)=='9') n=9;
	}

	return(sign*n);
    }


    public static int getOffset(String TEMP) {
	int n=0;
	for(int i=0;i<TEMP.length();++i) {
	    if(TEMP.charAt(i)=='#')++n;
	}
	return(n);
    }


    public static StringProcess extract(String T,String U) {
	StringProcess LEX=lexicon(U);
	StringProcess X=new StringProcess();
	int temp=-1;
	int N=T.length();
	for(int i=0;i<N;++i) {
	    char curr=T.charAt(i);
	    char prev=' ';
	    if(i>0) prev=T.charAt(i-1);
	    char[] add_on={curr};

	    boolean test_curr=Character.isWhitespace(curr);
	    boolean test_prev=Character.isWhitespace(prev);
	    if(i==0) test_prev=true;

	    if((test_prev==true)&&(test_curr==false)) {
	                   ++temp;
	                   X.S[temp]=new String(add_on);
		 for(int q=0;q<LEX.count;++q) {
		     if(curr==LEX.R[q]) X.S[temp]=new String(LEX.S[q]);
		 }
	       }

	    if((test_curr==false)&&(test_prev==false)) {
		int plain=1;
	                   for(int q=0;q<LEX.count;++q) {
		      if(curr==LEX.R[q]) {
                                                  X.S[temp]=X.S[temp]+new String(LEX.S[q]);
		              plain=0;
		      }
		  }
	               if(plain==1)     X.S[temp]=X.S[temp]+new String(add_on);
	    }
	}
	X.count=temp+1;
	for(int i=0;i<X.count;++i) {
	        X.s[i]=getNumber(X.S[i]);
	        X.t[i]=getOffset(X.S[i]);
                          X.S[i]=allCaps(X.S[i]);
	}


	return(X);
    }



    public static StringProcess extract(String T,String V,String W) {
	StringProcess X=new StringProcess();
	int temp=-1;
	int N=T.length();
	for(int i=0;i<N;++i) {
	    char curr=T.charAt(i);
	    char prev=' ';
	    if(i>0) prev=T.charAt(i-1);
	    char[] add_on={curr};
	    String RV=StringSearch.reverse(V);
	    String RW=StringSearch.reverse(W);

	    boolean test_curr=Character.isWhitespace(curr);
	    boolean test_prev=Character.isWhitespace(prev);
	    if(i==0) test_prev=true;

	    if((test_prev==true)&&(test_curr==false)) {
	        ++temp;
	         X.S[temp]=new String(add_on);
	         if(curr=='v') X.S[temp]=new String(V);
	         if(curr=='w') X.S[temp]=new String(W);
	         if(curr=='V') X.S[temp]=new String(RV);
	         if(curr=='W') X.S[temp]=new String(RW);
	         X.s[temp]=1;
	       }

	    if((test_curr==false)&&(test_prev==false)) {
	         if((curr!='v')&&(curr!='w')) X.S[temp]=X.S[temp]+new String(add_on);  
                           if(curr=='v') X.S[temp]=X.S[temp]+new String(V);
	         if(curr=='w') X.S[temp]=X.S[temp]+new String(W);   
                           if(curr=='V') X.S[temp]=X.S[temp]+new String(RV);
	         if(curr=='W') X.S[temp]=X.S[temp]+new String(RW);   

	       }

	       if(curr=='-') X.s[temp]=-1;
	}
	X.count=temp+1;
	for(int i=0;i<X.count;++i) {
	        X.s[i]=getNumber(X.S[i]);
	        X.t[i]=getOffset(X.S[i]);
                          X.S[i]=allCaps(X.S[i]);
	}


	return(X);
    }


    public static StringProcess split(String T) {
	StringProcess X=new StringProcess();
	int temp=-1;
	int N=T.length();

	for(int i=0;i<N;++i) {
	    char curr=T.charAt(i);
	    char prev=' ';
	    if(i>0) prev=T.charAt(i-1);
	    char[] add_on={curr};

	    boolean test_curr=Character.isWhitespace(curr);
	    boolean test_prev=Character.isWhitespace(prev);
	    if(i==0) test_prev=true;

	    if((test_prev==true)&&(test_curr==false)) {
	        ++temp;
	         X.S[temp]=new String(add_on);
	       }

	    if((test_curr==false)&&(test_prev==false)) {
	         X.S[temp]=X.S[temp]+new String(add_on);  
	       }

	       if(curr=='-') X.s[temp]=-1;
	}
	X.count=temp+1;
	return(X);
    }








    public static StringProcess lexicon(String T) {
	StringProcess U=split(T);
	StringProcess V=new StringProcess();
	int count=0;
	for(int i=0;i<U.count;++i) {
	    char x1=U.S[i].charAt(0);
	    char x2=U.S[i].charAt(1);
	    if(x2=='=') {
		V.R[count]=x1;
		V.S[count]=U.S[i].substring(2,U.S[i].length());
		++count;
	    }
	}
	V.count=count;
	return(V);
    }




    public void print() {
	for(int i=0;i<count;++i) {
	    System.out.println(s[i]+" "+S[i]);
	}
    }


}